//NETV2TSO JOB ,FORGHETT.RALVMM,MSGLEVEL=(1,1),CLASS=A                  00000100
//        EXEC ASMHCL,PARM.ASM='OBJECT,DECK,RENT,XREF(SHORT)',          00000200
//             PARM.LKED='LIST,RENT,XREF,MAP,AMODE=31,RMODE=ANY',       00000300
//             COND.PRINT=                                              00000310
//ASM.SYSIN     DD *                                                    00000400
NETV2TSO CSECT                                                          00000500
R0       EQU   0                                                        00000600
R1       EQU   1                                                        00000700
R2       EQU   2                                                        00000800
R3       EQU   3                                                        00000900
R4       EQU   4                                                        00001000
R5       EQU   5                                                        00001100
R6       EQU   6                                                        00001200
R7       EQU   7                                                        00001300
R8       EQU   8               DSIMVT BASE REGISTER                     00001400
R9       EQU   9               DSITVB BASE REGISTER                     00001500
R10      EQU   10              DSITIB BASE REGISTER                     00001600
R11      EQU   11              DSICWB BASE REGISTER                     00001700
R12      EQU   12              PROGRAM BASE REGISTER                    00001800
R13      EQU   13              SAVEAREA                                 00001900
R14      EQU   14                                                       00002000
R15      EQU   15                                                       00002100
         EJECT                                                          00002200
*********************************************************************** 00002300
*********************************************************************** 00002400
***                                                                 *** 00002500
***  (C)  Copyright  IBM  Corp.  1994                               *** 00002600
***  No warranty expressed or implied.                              *** 00002700
***                                                                 *** 00002800
***                     N E T V 2 T S O                             *** 00002900
***                                                                 *** 00003000
***                                                                 *** 00003100
***  NETV2TSO is a NetView command processor that is part of a      *** 00003110
***  package of tools that allows you to issue commands from a TSO  *** 00003120
***  user to NetView and have the command responses sent back.      *** 00003130
***                                                                 *** 00003150
***  The package uses the LU 6.2 High Performance Transport to      *** 00003160
***  send the commands and receive the responses.                   *** 00003170
***                                                                 *** 00003191
***  The package consists of 3 pieces:                              *** 00003200
***                                                                 *** 00003210
***      TSO2NETV - TSO assembler command processor that sends the  *** 00003220
***                 command to NetView, waits for the response,     *** 00003221
***                 and then displays the response.                 *** 00003230
***                                                                 *** 00003250
***      NETVCMD  - NetView REXX Clist which receives the command,  *** 00003260
***                 issues it, traps the output, and then issues    *** 00003270
***                 the NETV2TSO command to send the response back  *** 00003271
***                 to the TSO user.                                *** 00003290
***                                                                 *** 00003291
***      NETV2TSO - NetView assembler command processor that sends  *** 00003292
***                 the command response back to the TSO user.      *** 00003293
***                                                                 *** 00003296
***  You must register the TSO users to the NetView LU 6.2 High     *** 00003300
***  Performance task DSIHSNDS and have it execute the NETVCMD      *** 00003310
***  REXX clist when it receives data.                              *** 00003311
***                                                                 *** 00003312
***  The application names to register are the TSO userids that     *** 00003320
***  you will allow to send commands to NetView.  The REGISTER      *** 00003330
***  commands can be issued on a single autotask or multiple        *** 00003340
***  autotasks (improve throughput).                                *** 00003350
***                                                                 *** 00003351
***  Register command syntax:                                       *** 00003352
***                                                                 *** 00003360
***    REGISTER TYPE=REGHP,COMMAND=NETVCMD,LOGMODE=PARALLEL,        *** 00003370
***             APPL=NETV2TSO                                       *** 00003380
***                                                                 *** 00003390
***                                                                 *** 00003600
***  Installation:                                                  *** 00003700
***                                                                 *** 00003800
***        1) Assemble and linkedit code as reentrant               *** 00003900
***                                                                 *** 00004000
***           AMODE=31, RMODE=ANY for MVS                           *** 00004100
***                                                                 *** 00004200
***        2. Add CMDMDL statement to DSICMD                        *** 00004300
***                                                                 *** 00004400
***           NETV2TSO CMDMDL MOD=NETV2TSO,TYPE=R                   *** 00004500
***                                                                 *** 00004600
***                                                                 *** 00005600
***  Gary Forghetti                                                 *** 00005700
***  IBM Corporation                                                *** 00005800
***  Network Mgmt Products Field Support                            *** 00005900
***  Research Triangle Park, North Carolina                         *** 00006000
***                                                                 *** 00006100
*********************************************************************** 00006200
*********************************************************************** 00006300
         EJECT                                                          00006400
         PRINT OFF                                                      00006500
         DSICBS DSICWB,DSIMVT,DSIPDB,DSISVL,DSISWB,DSITIB,DSITVB,      X00006600
               DSITID,DSIDSRB,DSIGFPL,DSIIFR,PRINT=NO                   00006700
         PRINT ON                                                       00006800
         USING *,R15                                                    00006900
         B     PROLOG                                                   00007000
         DC    C'NETV2TSO    &SYSDATE. AT &SYSTIME. '                   00007100
         DC    C'COPYRIGHT IBM CORPORATION 1991, '                      00007200
         DC    C'NO WARRANTY EXPRESSED OR IMPLIED. '                    00007300
PROLOG   DS    0H                                                       00007400
         GBLC  &DSISYST                DEFINE NAME OF OPERATING SYS     00007500
         DSISYS                        DETERMINE NAME OF OPERATING SYS  00007600
         STM   R14,R12,12(R13)         SAVE REGISTERS                   00007700
         LR    R12,R15                 SET BASE ADDRESS                 00007800
         DROP  R15                                                      00007900
         USING NETV2TSO,R12            ESTABLISH PROGRAM BASE REGISTER  00008000
         LR    R11,R1                  GET CWB ADDR                     00008100
         USING DSICWB,R11              ESTABLISH BASE FOR DSICWB        00008200
         LA    R2,CWBSAVEA             GET SAVEAREA ADDR                00008300
         ST    R2,8(R13)               STORE THIS SA IN CALLERS         00008400
         ST    R13,4(R2)               STORE CALLERS SA IN THIS SA      00008500
         LR    R13,R2                  R13 NOW HAS THIS SAVEAREA ADDR   00008600
         L     R10,CWBTIB              GET DSITIB ADDRESS               00008700
         USING DSITIB,R10              ESTABLISH BASE FOR DSITBI        00008800
         L     R9,TIBTVB               GET DSITVB ADDRESS               00008900
         USING DSITVB,R9               ESTABLISH BASE FOR DSITVB        00009000
         L     R8,TVBMVT               GET DSIMVT ADDRESS               00009100
         USING DSIMVT,R8               ESTABLISH BASE FOR DSIMVT        00009200
*                                                                       00009300
         XC    CWBADATD,CWBADATD       CLEAR WORKAREA                   00009400
*                                                                       00009500
         DSIDATIM AREA=DATETIME,FORMAT=BINARY                           00009600
*                                                                       00009700
         BAL   R14,GETPARM             PARSE AND SYNTAX CHECK PARMS     00009800
*                                                                       00009900
         OC    RETCODE,RETCODE         ANY ERRORS?                      00010000
         BNZ   RETURN                  YES, EXIT                        00010100
*                                                                       00010200
         BAL   R14,MAINRTN             PERFORM MAIN LINE                00010300
*                                                                       00010400
RETURN   EQU   *                                                        00010500
         L     R15,RETCODE             GET ERROR CODE                   00010600
         L     R13,4(R13)              RESTORE CALLERS SAVEAREA ADDRESS 00010700
         RETURN (14,12),RC=(15)        RETURN                           00010800
         EJECT                                                          00024200
MAINRTN  EQU   *                                                        00024300
         ST    R14,RMAINRTN           SAVE RETURN ADDRESS               00024400
*                                                                       00024410
         BAL   R14,GETSTOR            GET STORAGE FOR BUFFER            00024411
*                                                                       00024412
         OC    RETCODE,RETCODE        OKAY?                             00024413
         BNZ   MAINRTNX               NO, EXIT                          00024414
*                                                                       00024415
         L     R2,BUFFADDR            GET ADDRESS OF THE BUFFER         00024416
*                                                                       00024417
         STH   R3,0(R2)               PUT LENGTH IN BUFFER              00024418
         MVC   2(2,R2),=X'1212'       x'1212' GDS KEY                   00024419
         LA    R2,4(R2)               INCREMENT PAST LENGTH + KEY       00024421
*                                                                       00024422
         MVC   0(2,R2),=X'0004'       x'0061' GDS LENGTH                00024425
         MVC   2(2,R2),=X'0061'       x'0061' GDS KEY                   00024426
         LA    R2,4(R2)               INCREMENT PAST LENGTH + KEY       00024427
*                                                                       00024428
         SH    R3,=H'8'               GET LENGTH OF X'1300'             00024429
         STH   R3,0(R2)               PUT LENGTH IN BUFFER              00024430
         MVC   2(2,R2),=X'1300'       x'1300' GDS KEY                   00024431
         LA    R2,4(R2)               INCREMENT PAST LENGTH + KEY       00024432
*                                                                       00024433
         L     R6,TVBAIIFR            GET ADDRESS OF AIFR               00024434
*                                                                       00024440
         USING BUFHDR,R6              R6 IS BASE FOR BUFFER (AIFR)      00024450
         AH    R6,HDRTDISP            POSITION TO AIFR                  00024460
         DROP  R6                                                       00024470
*                                                                       00024480
         USING DSIIFR,R6              R6 IS BASE FOR DSIIFR             00024490
         L     R6,IFRAUTBA            GET ADDRESS OF 1ST MESSAGE        00024500
         DROP  R6                                                       00024501
         USING BUFHDR,R6                                                00024502
*                                                                       00024505
MAINRTN1 EQU   *                                                        00024506
*                                                                       00024507
         LTR   R6,R6                  ANY MORE LINES?                   00024508
         BZ    MAINRTN2               NO, TIME TO SEND THE DATA         00024509
*                                                                       00024510
         LH    R3,HDRMLENG            GET MESSAGE LENGTH                00024511
         LA    R3,2(R3)               ADD 2 FOR SV X'31' KEY AND LENGTH 00024512
         STC   R3,0(R2)               PUT LENGTH IN BUFFER              00024515
         MVI   1(R2),X'31'            X'31' SUBVECTOR KEY               00024516
         LA    R2,2(R2)               INCREMENT PAST HEADER             00024517
*                                                                       00024518
         LH    R3,HDRMLENG            GET MESSAGE LENGTH                00024519
         LR    R5,R3                  GET LENGTH FOR MVCL               00024520
         LR    R4,R6                  GET BUFFER ADDRESS                00024521
         AH    R4,HDRTDISP            INCREMENT TO MESSAGE TEXT         00024522
         MVCL  R2,R4                  MOVE MESSAGE TO BUFFER            00024524
*                                                                       00024525
         L     R6,HDRNEXTM            GET ADDRESS OF NEXT LINE          00024526
         B     MAINRTN1               KEEP BUILDING                     00024527
*                                                                       00024528
MAINRTN2 EQU   *                                                        00024529
*                                                                       00026400
         L     R2,BUFFADDR             GET ADDRESS OF DATA BUFFER       00026500
*                                                                       00026800
         CLC   0(2,R2),=H'31743'                                        00026801
         BNH   MAINRTN3                                                 00026802
*                                                                       00026803
         MVC   0(2,R2),=H'31743'                                        00026804
*                                                                       00026805
MAINRTN3 EQU   *                                                        00026806
*                                                                       00026810
         DSIHSNDS SWB=CWBSWB,          SEND DATA                       *00026900
               DATATYP=NONMDSMU,       NOT A MDSMU                     *00027000
               DATA=(R2),              DATA TO SEND                    *00027100
               CORAREA=CORAREA,        AGENT UNIT OF WORK CORRELATOR   *00027200
               ORIGAPP=ORIGAPPL,       APPLICATION NAME                *00027300
               DESTLU=LUNAME,          DESTINATION LU NAME             *00027400
               DESTAPP=DESTAPPL,       DESTINATION APPLICATION NAME    *00027500
               MUTYPE=MUTYPE           MDS MU TYPE                      00027600
*                                                                       00027700
         ST    R15,RETCODE             SAVE RETURN CODE                 00027800
*                                                                       00027900
         LTR   R15,R15                 SEND SUCESSFUL?                  00028000
         BZ    MAINRTN4                YES, CONTINUE                    00028100
*                                                                       00028200
         MVC   MESSAGE(L'ERRMSG1),ERRMSG1                               00028300
         CVD   R15,DBLEWORD                                             00028400
         UNPK  MESSAGE+L'ERRMSG1(4),DBLEWORD+5(3)                       00028500
         OI    MESSAGE+L'ERRMSG1+3,X'F0'                                00028600
         LA    R1,L'ERRMSG1+4                                           00028700
         BAL   R14,DISPMSG             DISPLAY THE ERROR MESSAGE        00028800
*                                                                       00028900
MAINRTN4 EQU   *                                                        00029000
*                                                                       00029100
         L     R3,BUFFSIZE             GET LENGTH OF BUFFER             00029200
         DSIFRE LV=(R3),               FREE STORAGE FOR BUFFER         *00029400
               A=BUFFADDR,                                             *00029500
               Q=YES                                                    00029600
*                                                                       00029700
MAINRTNX EQU   *                                                        00029800
         L     R14,RMAINRTN            RESTORE RETURN ADDRESS           00029900
         BR    R14                     RETURN                           00030000
         EJECT                                                          00030001
GETSTOR  EQU   *                                                        00030002
         ST    R14,RGETSTOR           SAVE RETURN ADDRESS               00030003
*                                                                       00030020
         L     R6,TVBAIIFR            GET ADDRESS IF AIFR               00030030
*                                                                       00030040
         USING BUFHDR,R6              R6 IS BASE FOR BUFFER (AIFR)      00030050
         AH    R6,HDRTDISP            POSITION TO AIFR                  00030060
         DROP  R6                                                       00030070
*                                                                       00030080
         USING DSIIFR,R6              R6 IS BASE FOR DSIIFR             00030090
         L     R6,IFRAUTBA            GET ADDRESS OF 1ST MESSAGE        00030091
         DROP  R6                                                       00030092
         USING BUFHDR,R6                                                00030093
*                                                                       00030094
         LA    R3,12                  START WITH 12 BYTES FOR HEADERS   00030095
*                                          X'....1212'                  00030096
*                                          X'....0061'                  00030097
*                                          X'....1300'                  00030098
*                                                                       00030099
GETSTOR1 EQU   *                                                        00030100
*                                                                       00030108
         LTR   R6,R6                  ANY MORE LINES?                   00030109
         BZ    GETSTOR2               NO, TIME TO GET STORAGE           00030110
*                                                                       00030111
         LA    R3,2(R3)               ADD 2 FOR SV31 X'..31'            00030112
         AH    R3,HDRMLENG            ADD IN MESSAGE LENGTH             00030113
*                                                                       00030114
         L     R6,HDRNEXTM            GET ADDRESS OF NEXT LINE          00030115
         B     GETSTOR1               KEEP CHECKING                     00030116
*                                                                       00030117
         DROP  R6                                                       00030118
*                                                                       00030119
GETSTOR2 EQU   *                                                        00030120
*                                                                       00030121
         ST    R3,BUFFSIZE            SAVE SIZE OF BUFFER               00030122
*                                                                       00030123
         DSIGET LV=(R3),              GET STORAGE FOR BUFFER           *00030124
               A=BUFFADDR,                                             *00030125
               Q=YES,                                                  *00030126
               CLEAR=YES                                                00030127
*                                                                       00030128
         ST    R15,RETCODE            SAVE RETURN CODE                  00030129
*                                                                       00030131
GETSTORX EQU   *                                                        00030132
         L     R14,RGETSTOR           GET RETURN ADDRESS                00030134
         BR    R14                                                      00030135
         EJECT                                                          00030136
GETPARM  EQU   *                                                        00030137
         ST    R14,RGETPARM            SAVE RETURN ADDRESS              00030138
*                                                                       00030139
         L     R4,CWBBUF               GET COMMAND BUFFER ADDRESS       00030140
         USING DSIPDB,R3               R3 IS BASE FOR PDB               00030141
         L     R3,CWBPDB               GET PDB ADDRESS                  00030142
         USING PDBENTRY,R2             R2 IS BASE FOR PDB ENTRY         00030143
         LA    R2,PDBTABLE             GET ADDRESS OF 1ST PDB ENTRY     00030144
         AH    R4,PDBDISP              GET ADDRESS OF 1ST PARM          00030145
         SR    R5,R5                   CLEAR LENGTH REGISTER            00030146
         IC    R5,PDBLENG              GET LENGTH OF 1ST PARM           00030147
         BCTR  R5,0                    MAKE LENGTH EXECUTEABLE FOR MOVE 00030148
         MVC   CMDNAME,=CL8' '         CLEAR COMMAND NAME               00030149
         EX    R5,MOVECMD              MOVE THE COMMAND TO WORKAREA     00030150
*                                                                       00030151
         MVC   PARM,=CL8'LUNAME'       INDICATE LUNAME PARAMETER        00030152
*                                                                       00030153
         CLC   PDBNOENT,=H'2'          AT LEAST 2 ENTRIES?              00030154
         BL    GETPARM1                NO, ERROR                        00030155
*                                                                       00030156
         L     R4,CWBBUF               GET COMMAND BUFFER ADDRESS       00030157
         LA    R0,PDBENTND-PDBENTRY    GET LENGTH OF PDBENTRY           00030158
         AR    R2,R0                   POINT TO 2ND ENTRY               00030159
         SR    R5,R5                   CLEAR LENGTH REGISTER            00030160
         IC    R5,PDBLENG              GET LENGTH OF 2ND PARM           00030161
         AH    R4,PDBDISP              GET ADDRESS OF 2ND PARM          00030162
*                                                                       00030163
         LTR   R5,R5                   IS THERE A RECOGNIZABLE PARM     00030164
         BZ    GETPARM1                NO, ERROR                        00030165
*                                                                       00030166
         CH    R5,=H'8'                PARM GREATER THAN 8?             00030167
         BH    GETPARM2                YES, ERROR                       00030168
*                                                                       00030169
         MVC   LUNAME,=CL8' '          CLEAR LUNAME                     00030170
         BCTR  R5,0                    MAKE LENGTH EXECUTEABLE FOR MOVE 00030171
         EX    R5,MOVELU               MOVE THE PARM TO THE TASK        00030172
*                                                                       00030173
         B     GETPARMX                EXIT                             00030174
*                                                                       00030175
GETPARM1 EQU   *                       MISSING PARAMETER                00030176
*                                                                       00030177
         BAL   R14,DSI651I             DISPLAY MESSAGE DSI651I          00030178
         B     GETPARMX                EXIT                             00030179
*                                                                       00030180
GETPARM2 EQU   *                       KEYWORD HAS INVALID VALUE        00030181
*                                                                       00030182
         MVI   ERRORTXT,X'40'          CLEAR ERROR TEXT FIELD           00030183
         MVC   ERRORTXT+1(L'ERRORTXT-1),ERRORTXT                        00030184
*                                                                       00030185
         CH    R5,=AL2(ERRORTXL)       MORE THAN SIZE OF ERRORTXT?      00030186
         BNH   GETPARM4                NO, CONTINUE                     00030187
*                                                                       00030188
         LA    R5,L'ERRORTXT           MAKE IT SIZE OF ERRORTXT         00030189
*                                                                       00030190
GETPARM4 EQU   *                                                        00030191
*                                                                       00030192
         BCTR  R5,0                    MAKE LENGTH EXECUTEABLE          00030193
         EX    R5,MOVETEXT             GET TEXT IN ERROR                00030194
         BAL   R14,DSI649I             ISSUE MESSAGE DSI649I            00030195
*                                                                       00030196
GETPARMX EQU   *                                                        00030197
         L     R14,RGETPARM            RESTORE RETURN ADDRESS           00030198
         BR    R14                     RETURN                           00030199
         SPACE                                                          00030200
MOVECMD  MVC   CMDNAME(0),0(R4)        GET COMMAND NAME                 00030201
MOVELU   MVC   LUNAME(0),0(R4)         GET DESTINATION LU               00030202
MOVETEXT MVC   ERRORTXT(0),0(R4)       GET TEXT IN ERROR                00030203
         DROP  R2,R3                                                    00030204
         EJECT                                                          00030205
CHEKDELM EQU   *                                                        00030206
         CLI   0(R2),X'40'             IS BYTE A BLANK?                 00030207
         BER   R14                     YES, EXIT WITH COND CODE         00030208
         CLI   0(R2),C','              IS BYTE A COMMA?                 00030209
         BR    R14                     EXIT UNCONDITIONAL               00030210
*                                                                       00030211
         EJECT                                                          00030212
*                                                                       00030220
* DSI649I KEYWORD '&1' HAS INVALID VALUE: '&2'                          00030300
*                                                                       00030400
DSI649I  EQU   *                                                        00030500
         ST    R14,RMESSAGE            SAVE RETURN ADDRESS              00030600
         SR    R3,R3                   CLEAR LENGTH REGISTER            00030700
         LA    R2,ERRORTXT             R2 HAS ADDRESS OF ERRORTXT       00030800
         LA    R5,L'ERRORTXT           GET SIZE OF ERRORTXT             00030900
DSI649I1 EQU   *                                                        00031000
         BAL   R14,CHEKDELM            IS BYTE A DELIMITER?             00031100
         BE    DSI649I2                YES, SEARCH IS DONE              00031200
         LA    R3,1(R3)                UPDATE LENGTH OF TEXT            00031300
         LA    R2,1(R2)                INCREMENT TO NEXT CHARACTER      00031400
         BCT   R5,DSI649I1             CHECK ALL 15 BYTES               00031500
DSI649I2 EQU   *                                                        00031600
*                                                                       00031700
         USING BUFHDR,R2               R2 IS BASE FOR BUFHDR            00031800
         LA    R2,MSGBUFF              GET ADDRESS OF MESSAGE BUFFER    00031900
         XC    MSGBUFF,MSGBUFF         CLEAR MESSAGE BUFFER             00032000
         LA    R1,BUFHDRND-BUFHDR      GET OFFSET TO MESSAGE TEXT       00032100
         STH   R1,HDRTDISP             PUT OFFSET IN BUFHDR             00032200
         LA    R1,L'MESSAGE(R1)        GET LENGTH OF BUFFER             00032300
         STH   R1,HDRBLENG             STORE IN BUFFER                  00032400
         DSIMBS SWB=CWBSWB,MID=649,BFR=(R2),MSGTBL=MVTMCC,             *00032500
               P1=(PARM,8),P2=(ERRORTXT,(R3))                           00032600
         MVI   HDRMTYPE,HDRTYPEN       INDICATE ITS A NETVIEW MESSAGE   00032700
         BAL   R14,WRITMSG             DISPLAY THE MESSAGE              00032800
         DROP  R2                      DROP R2 AS BASE REGISTER         00032900
*                                                                       00033000
         MVC   RETCODE,=F'8'           SET RETURN CODE                  00033100
DSI649IX EQU   *                                                        00033200
         L     R14,RMESSAGE            RESTORE RETURN ADDRESS           00033300
         BR    R14                     RETURN                           00033400
         EJECT                                                          00033500
*                                                                       00033600
* DSI651I KEYWORD MISSING - ONE OF THE FOLLOWING REQUIRED: '&1'         00033700
*                                                                       00033800
DSI651I  EQU   *                                                        00033900
         ST    R14,RMESSAGE            SAVE RETURN ADDRESS              00034000
*                                                                       00034100
         USING BUFHDR,R2               R2 IS BASE FOR BUFHDR            00034200
         LA    R2,MSGBUFF              GET ADDRESS OF MESSAGE BUFFER    00034300
         XC    MSGBUFF,MSGBUFF         CLEAR MESSAGE BUFFER             00034400
         LA    R1,BUFHDRND-BUFHDR      GET OFFSET TO MESSAGE TEXT       00034500
         STH   R1,HDRTDISP             PUT OFFSET IN BUFHDR             00034600
         LA    R1,L'MESSAGE(R1)        GET LENGTH OF BUFFER             00034700
         STH   R1,HDRBLENG             STORE IN BUFFER                  00034800
         DSIMBS SWB=CWBSWB,MID=651,BFR=(R2),MSGTBL=MVTMCC,             *00034900
               P1=(PARM,8)                                              00035000
         MVI   HDRMTYPE,HDRTYPEN       INDICATE ITS A NETVIEW MESSAGE   00035100
         BAL   R14,WRITMSG             DISPLAY THE MESSAGE              00035200
         DROP  R2                      DROP R2 AS BASE REGISTER         00035300
*                                                                       00035400
         MVC   RETCODE,=F'8'           SET RETURN CODE                  00035500
DSI651IX EQU   *                                                        00035600
         L     R14,RMESSAGE            RESTORE RETURN ADDRESS           00035700
         BR    R14                     RETURN                           00035800
         EJECT                                                          00035900
DISPMSG  EQU   *                                                        00036000
         ST    R14,RDISPMSG            SAVE RETURN ADDRESS              00036100
*                                                                       00036200
         USING BUFHDR,R2                                                00036300
         LA    R2,MSGBUFF              GET ADDRESS OF BUFFER            00036400
         STH   R1,HDRMLENG             PUT LENGTH IN BUFFER HEADER      00036500
         LA    R1,HDRMSGLN             GET OFFSET TO MSG TEXT           00036600
         STH   R1,HDRTDISP             MOVE MESSAGE OFFSET TO BUFFER    00036700
         AH    R1,HDRMLENG             GET LENGTH OF BUFFER             00036800
         STH   R1,HDRBLENG             STORE IN BUFFER                  00036900
         MVC   HDRDOMID,MVTCURAN       MOVE DOMAIN ID TO BUFFER         00037000
         MVC   HDRTSTMP,TIME           MOVE TIME TO BUFFER              00037100
         MVI   HDRMTYPE,HDRTYPEU       NETVIEW MESSAGE                  00037200
         DROP  R2                                                       00037300
*                                                                       00037400
         BAL   R14,WRITMSG             GO DISPLAY MESSAGE               00037500
*                                                                       00037600
DISPMSGX EQU   *                                                        00037700
         L     R14,RDISPMSG            RESTORE RETURN ADDRESS           00037800
         BR    R14                     RETURN                           00037900
         EJECT                                                          00038000
WRITMSG  EQU   *                                                        00038100
         ST    R14,RWRITMSG            SAVE RETURN ADDRESS              00038200
         DSIPSS SWB=CWBSWB,BFR=(R2),TYPE=OUTPUT                         00038300
WRITMSGX EQU   *                                                        00038400
         L     R14,RWRITMSG            RESTORE RETURN ADDRESS           00038500
         BR    R14                     RETURN                           00038600
         EJECT                                                          00038700
         LTORG                                                          00038800
         EJECT                                                          00038900
*                                                                       00039000
ERRMSG1  DC    C'NETV2TSO - DSIHSNDS MACRO FAILED, R15='                00039100
         DC    CL4' '                                                   00039200
*                                                                       00039210
DESTAPPL DC    CL8'TSO2NETV'           TSO LU 6.2 HP APPLICATION        00039300
ORIGAPPL DC    CL8'NETV2TSO'           NETVIEW LU 6.2 HP APPLICATION    00039301
MUTYPE   DC    F'2'                    REQUEST WITHOUT REPLY            00039310
         EJECT                                                          00039400
DSICWB   DSECT                                                          00039500
         ORG   CWBADATD                                                 00039600
DBLEWORD DS    D                       DOUBLE WORD WORK AREA            00039700
DATETIME DS    0D                      DOUBLE WORD WORK AREA            00039800
DATE     DS    F                       DATE IN BINARY                   00039900
TIME     DS    F                       TIME IN BINARY                   00040000
RETCODE  DS    F                       RETURN CODE                      00040100
RMAINRTN DS    F                       BRANCH RETURN ADDRESS            00040200
RGETPARM DS    F                       BRANCH RETURN ADDRESS            00040300
RGETSTOR DS    F                       BRANCH RETURN ADDRESS            00040310
RMESSAGE DS    F                       BRANCH RETURN ADDRESS            00040400
RWRITMSG DS    F                       BRANCH RETURN ADDRESS            00040500
RDISPMSG DS    F                       BRANCH RETURN ADDRESS            00040600
BUFFSIZE DS    F                       SIZE OF SEND BUFFER              00040700
BUFFADDR DS    F                       ADDRESS OF SEND BUFFER           00040710
HALFWORD DS    H                       HALFWORD WORK AREA               00041010
CMDNAME  DS    CL8                     COMMAND NAME                     00041100
LUNAME   DS    CL8                     LUNAME                           00041200
PARM     DS    CL8                     PARM IN ERROR                    00041400
ERRORTXT DS    XL10                                                     00041500
ERRORTXL EQU   *-ERRORTXT                                               00041600
         DS    0F                                                       00041700
CORAREA  DS    XL52                    UNIT OF WORK CORRELATOR          00041800
         ORG   CORAREA                                                  00041900
MSGBUFF  DS    0XL(L'MESSAGE+HDRMSGLN)                                  00042000
         DS    XL(HDRMSGLN)                                             00042100
MESSAGE  DS    CL100                                                    00042200
         DS    XL(256-(*-CWBADATD))                                     00042300
         END   NETV2TSO                                                 00042400
//LKED.SYSLMOD DD DSN=ESP.E240.LINKLIB(NETV2TSO),DISP=SHR               00042500
//                                                                      00042600
