/**********************************************************************/00000300
/* NETVCMD                                                            */00000400
/**********************************************************************/00000410
/*                                                                    */00000420
/* (C) Copyright IBM Corporation 1994                                 */00000500
/* No warranty expressed or implied                                   */00000600
/*                                                                    */00000700
/* This clist gets triggered when a command is received from a TSO    */00000800
/* user from the TSO LU 6.2 HP command TSO2NETV.  It receives the     */00000900
/* command, issues it, traps the ouput, and then sends it back to the */00001000
/* TSO user via the NETV2TSO LU 6.2 HP NetView command.               */00001010
/*                                                                    */00001200
/* A register command must be entered for the NETV2TSO LU 6.2 HP      */00001300
/* application to receive the commands from the TSO users and to      */00001400
/* drive this REXX clist.  The REGISTER command should be driven on   */00001500
/* an autotask.                                                       */00001600
/*                                                                    */00001610
/*    REGISTER TYPE=REGHP,COMMAND=NETVCMD,LOGMODE=PARALLEL,           */00001700
/*             APPL=NETV2TSO                                          */00001800
/*                                                                    */00002040
/*                                                                    */00002050
/* Gary Forghetti                                                     */00002100
/* IBM Corporation                                                    */00002200
/* Network Mgmt Products Field Support                                */00002300
/* Research Triangle Park, North Carolina                             */00002400
/*                                                                    */00002540
/**********************************************************************/00002600
                                                                        00002700
if netview()<'NV23'                                                     00002710
   then                                                                 00002720
       do                                                               00002730
         say "This version of NETVCMD uses PIPES and requires "||,      00002740
             "NetView V2R3 or above.  It will not run on NetView V"||,  00002741
             substr(netview(),3,1)"R"||,                                00002750
             substr(netview(),4,1)"."                                   00002760
         exit                                                           00002770
       end                                                              00002780
                                                                        00002790
if msuseg('h1212')='' |,                 /* Exit if no CP_MSU or      */00002800
   msuseg('8061.31')=''                  /* no Execute command MV     */00002900
  then                                                                  00003001
      exit                                                              00003002
                                                                        00003060
dlu=strip(msuseg('h1311.81.02',3),B,' ') /* Get originating lu name.  */00003100
                                                                        00003200
command=strip(msuseg('8061.31',3),B,' ') /* Get command to be executed*/00003300
                                                                        00003403
if substr(command,1,1)='$'                                              00003404
   then command='MVS '||command                                         00003405
                                                                        00003406
if substr(command,1,5)='MVS $'                                          00003407
   then command=command||',L=A'                                         00003408
                                                                        00003409
select                                                                  00003410
      when substr(command,1,2)='D '                                     00003411
           then                                                         00003412
               take=2                                                   00003413
      when substr(command,1,2)='V '                                     00003414
           then                                                         00003415
               take=2                                                   00003416
      when substr(command,1,2)='F '                                     00003417
           then                                                         00003418
               take=2                                                   00003419
      otherwise                                                         00003420
               take=1                                                   00003421
end                                                                     00003422
                                                                        00003423
'PIPE NETV 'command' |',                                                00003424
           'CORRWAIT 60 |',                                             00003425
           'TAKE 'take' |',                                             00003426
           'COLLECT |',                                                 00003427
           'NETV NETV2TSO 'dlu' |',                                     00003428
           'CONSOLE'                                                    00003430
                                                                        00011702
exit                                     /* Exit                      */00011800
